//Leons Petrazickis
//7of9 Events Generator
//Uses St Leo's Civ++ Event Engine V1.0

#include<fstream.h>
#include<string.h>	//Delete this

ofstream fout("events.txt");		//creates a variable of type fout

//Triggers
void citytaken(char city[255],
			   char attacker[255],
			   char defender[255]);
void negotiation(char talker[255],
				 char talkertype[255],
				 char listener[255],
				 char listenertype[255]);
void randomturn(int denominator);
void scenarioloaded();
void unitkilled(char unit[255],
				char attacker[255],
				char defender[255]);

//Actions
void createunit(char owner[255],
				char unit[255],
				char veteran[255],
				char homecity[255],
				char loc[255]);
void justonce();
void noschism(char defender[255]);
void playwavefile(char filename[255]);
void text(char text[32000]);

//Keywords
void beginevents();
void endevents();
void IF();
void THEN();
void ENDIF();
void debug();

//Useful Variable
char civs[8][256] = {
		"Collective",
		"Federation",
		"Klingons",
		"Romulans",
		"Cardassians",
		"Ferengi",
		"Other",
		"Barbarians"};

void main(){
	//Scenario-specific variables
	char answer = ' ';			//Answer to prompts
	int x=0;					//Index for loops
	int number = 5;
	int randfreq = 2;
	int generalinterval = 15;
	char assloc[] = "70,106";

	cout << "Welcome to the Setup Program for 7of9:\n";
	cout << "\t-Answer in lowercase and follow up with an [Enter]\n";
	cout << "\t-Run it again whenever needed\n";
	cout << "\t-If it summons aliens from Alpha Centauri, it is not my fault\n\n";

	beginevents();
	//debug();

	IF();
	noschism("ANYBODY");
	THEN();
	ENDIF();

	IF();
	scenarioloaded();
	THEN();
	playwavefile("79callme.wav");
	ENDIF();

	IF();
	unitkilled("Delta Flyer","ANYBODY","ANYBODY");
	THEN();
	createunit("Collective","Ass. Delta Flyer","No","NONE","153,5");
	playwavefile("79amborg.wav");
	ENDIF();

	IF();
	unitkilled("Voyager","ANYBODY","ANYBODY");
	THEN();
	createunit("Collective","Ass. Voyager","No","NONE","153,7");
	playwavefile("79futile.wav");
	ENDIF();

	IF();
	unitkilled("Wormhole1","ANYBODY","ANYBODY");
	THEN();
	createunit("Collective","Ass. Voyager","No","NONE","70,106/n68,106/n66,106/n68,110/n68,102");
	playwavefile("wormhole.wav");
	ENDIF();

	char ships[6][255]={
		"Galaxy Class",
		"Defiant",
		"K'Vort",
		"Warbird",
		"Marauder",
		"Cruiser"
	};
	char sounds[6][255]={
		"borg1.wav",
		"borg2.wav",
		"borg3.wav",
		"borg4.wav",
		"borg5.wav",
		"borg6.wav"
	};
	char temp[255] = "";
	for (x=0 ; x<6 ; x++){
		temp[0]=NULL;
		strcat(temp,"Ass. "); strcat(temp, ships[x]);

		IF();
		unitkilled(ships[x],"Collective","ANYBODY");
		THEN();
		createunit("Collective", temp,"No","NONE",assloc);
		playwavefile(sounds[x]);
		ENDIF();
	}

	IF();
	citytaken("Sol","ANYBODY","ANYBODY");
	THEN();
	playwavefile("queensol.wav");
	justonce();
	ENDIF();

	endevents();
	fout.close();
}

void createunit(char owner[255],
				char unit[255],
				char veteran[255],
				char homecity[255],
				char loc[255]){
	fout << "CreateUnit\n";
	fout << "owner=" << owner << "\n";
	fout << "unit=" << unit << "\n";
	fout << "veteran=" << veteran << "\n";
	fout << "homecity=" << homecity << "\n";
	fout << "locations\n" << loc << "\nendlocations\n";
}

void unitkilled(char unit[255],
				char attacker[255],
				char defender[255]){
	fout << "UnitKilled\n";
	fout << "unit=" << unit << "\n";
	fout << "attacker=" << attacker << "\n";
	fout << "defender=" << defender << "\n";
}

void randomturn(int denominator){
	fout << "RandomTurn\n";
	fout << "denominator=" << denominator << "\n";
}

void negotiation(char talker[255],
				 char talkertype[255],
				 char listener[255],
				 char listenertype[255]){
    fout << "Negotiation\n";
    fout << "talker=" << talker << "\n";
    fout << "talkertype="<< talkertype << "\n";
    fout << "listener="<< listener << "\n";
    fout << "listenertype="<< listenertype << "\n";
}

void text(char text[32000]){
	fout << "Text\n";
	fout << text << "\n";
	fout << "EndText\n";
}


void beginevents(){
	fout << "@BEGINEVENTS\n";
}

void endevents(){
	fout << "@ENDEVENTS\n";
}

void IF(){
	fout << "@IF\n";
}

void THEN(){
	fout << "@THEN\n";
}

void ENDIF(){
	fout << "@ENDIF\n";
}

void justonce(){
	fout << "JustOnce\n";
}

void noschism(char defender[255]){
	fout << "NoSchism\n";
	fout << "defender=" << defender << "\n";
}

void citytaken(char city[255],
			   char attacker[255],
			   char defender[255]){
	fout << "CityTaken\n";
	fout << "city=" << city << "\n";
	fout << "attacker=" << attacker << "\n";
	fout << "defender=" << defender << "\n";
}

void playwavefile(char filename[255]){
	fout << "PlayWaveFile\n";
	fout << filename << "\n";
}

void scenarioloaded(){
	fout << "ScenarioLoaded\n";
}

void debug(){
	fout << "@DEBUG\n";
}